require("luamods/command")
require("luamods/layout")
require("luamods/cgi")
require("config/rsm_conf")
require("luamods/rsm_serials")


header = layout.getHeader()
footer = layout.getFooter()

userLevel = db.getPriv(layout.username) or 1

if (userLevel == 1) then
    buttonControl = " disabled"
    inputControl = " readonly"
else
    buttonControl = ""
    inputControl = ""
end

serialConfig = command.ex([[cat ]]..rsm_conf.serialconfig_path) or ""

dlmsConfig = command.ex([[cat ]]..rsm_conf.ddd_xml_path) or ""
templatesFiles = {}
if (dlmsConfig ~= "") then
    dlmsPath = dlmsConfig:match([[<path%s+name=%"devices%"%s->(.-)</path>]]) or ""
    templatesPath = dlmsConfig:match([[<path%s+name=%"templates%"%s->(.-)</path>]]) or ""
    if (templatesPath ~= "") then
        templatesFiles = command.getFilesInTable(templatesPath)
    end
end

if (cgi.post.deleteButton == "Delete Device") and (userLevel ~= 1) then
    file = cgi.post.file or ""
    file = file:gsub("[^%w%.]+","")
    command.ex(rsm_conf.ddd_down)
    command.ex([[rm ]]..dlmsPath..[[/]]..file)
    command.ex(rsm_conf.ddd_up)
    label = cgi.post.label or "unknown"
    bus = cgi.post.bus or "unknown"
    -- Stop here
    content = [[
                    <div id="info">
                        <center><h1>Edit DLMS Device</h1></center>
                    </div>                  
                    <div id="info">
                        <center>
                            <h2><img src="images/ok.png"/> Device Deleted</h2>
                            Device with filename "]]..file..[[" has been removed.<br><br>
                            <a href="rsm_dlms_config.lua?bus=]]..bus..[[">Back to DLMS</a>
                        </center>
                    </div>
]]
    print(header..content..footer)
    os.exit()
end

if (cgi.post.saveButton == "Save and Apply") and (userLevel ~= 1) then
    newFile = cgi.post.file or ""
    newFile = newFile:gsub("[^%w%.]+","")
    if (newFile == "") then
        newSerial = rsm_serials.generateNewSerial()
        newFile = newSerial..".xml"
        createdNew = 1
    else
        createdNew = 0
        existingCfg = command.ex([[cat ]]..dlmsPath..[[/]]..newFile)
        newSerial = existingCfg:match([[<serial>%s-(.-)%s-</serial>]])
        if (newSerial == nil) then
            -- Bail on error
            content = [[
                    <div id="info">
                        <center><h1>Edit DLMS Device</h1></center>
                    </div>                  
                    <div id="info">
                        <center>
                            <h2><img src="images/warning.png"/> Filename / serial mismatch</h2>
                            The serial number of the device does not match the one in the file.<br>
                            <a href="rsm_bus_config.lua">Back to Bus Configuration</a>
                        </center>
                    </div>
]]
            print(header..content..footer)
            os.exit()
        end
    end
    newLabel = cgi.post.label or "unknown"
    newTemplate = cgi.post.template or "unknown"
    newConfig = cgi.post.config or rsm_conf.serialconfig_path
    newPort = cgi.post.bus or "unknown"
    newOwner = "ddd"

    --Get the make of the meter from the config file, required parameter to correctly initialize the connection
    dlmsConfig = command.ex([[cat ]]..rsm_conf.ddd_xml_path) or ""
    if (dlmsConfig ~= "") then
        dlms_templatesPath = dlmsConfig:match([[<path%s+name=%"templates%"%s->(.-)</path>]]) or ""
        if (dlms_templatesPath ~= "") then
            dlms_templateFiles = command.getFilesInTable(dlms_templatesPath)
        end
    end

    if (dlms_templateFiles ~= nil) then
        dlms_templates = {}
        for i,f in pairs(dlms_templateFiles) do
            templateXML = command.ex("cat "..dlms_templatesPath..[[/]]..f)
            template = {}
            template.make = templateXML:match("<make>%s-(.-)%s-</make>") or "?"
            dlms_templates[f] = template
        end
    end

    if (dlms_templates[newTemplate] ~= nil) then
        newMake = dlms_templates[newTemplate].make 
    end
    --End getting make of meter



    newXML = [[
<!-- ]]..dlmsPath..[[/]]..newFile..[[ generated by webconfig -->
<device>
    <label>]]..newLabel..[[</label>
    <serial>]]..newSerial..[[</serial>
    <template>]]..newTemplate..[[</template>
    <type>]]..newMake..[[</type>
    <serialport>
        <config>]]..newConfig..[[</config>
        <port>]]..newPort..[[</port>
    </serialport>
</device>
<!-- end of file -->
]]
    command.ex(rsm_conf.ddd_down)
    command.writefile(dlmsPath..[[/]]..newFile, newXML)
    command.ex(rsm_conf.ddd_up)
    filename = newFile
    saved = 1
    mode = "edit"
else
    filename = cgi.get.file or ""
    if (filename == "") then 
        mode = "new"
    else 
        filename = filename:gsub("[^%w%.]+","")
        mode = "edit"
    end
end    

bus = cgi.get.bus or cgi.post.bus or ""

b, bCfg = serialConfig:match([[<port%s+device=%"(]]..bus..[[)%"%s->(.-)</port>]])
if (b == bus) and (bCfg ~= nil) then
    if bCfg:match("<owner>%s-ddd%s-</owner>") == nil then
        mismatch = 1
    else
        mismatch = 0
    end
else
    mismatch = 1
end

if (mode == "edit") then
    
    cfg = command.ex([[cat ]]..dlmsPath..[[/]]..filename) or ""
    if (cfg:match("<device>(.+)</device>") == nil) then
        -- bail on error
        content = [[
                    <div id="info">
                        <center><h1>Edit DLMS Device</h1></center>
                    </div>            
                    <div id="info">
                        <center>
                            <h2><img src="images/warning.png"/> Invalid file</h2>
                            The specified file does not appear to be a valid DLMS device file.<br><br>
                            <a href="rsm_bus_config.lua">Back to bus configuration</a>
                        </center>
                    </div>
]]
        print(header..content..footer)
        os.exit()
    else
        d = {}
        d.label = cfg:match([[<label>%s-(.-)%s-</label>]]) or "unknown"
        d.serial = cfg:match([[<serial>%s-(.-)%s-</serial>]]) or "unknown"
        d.template = cfg:match([[<template>%s-(.-)%s-</template>]]) or "unknown"
        d.config = cfg:match([[<config>%s-(.-)%s-</config>]]) or rsm_conf.serialconfig_path
        d.port = cfg:match([[<port>%s-(.-)%s-</port>]])
        if (d.port ~= bus) then
            -- bail on error
            content = [[
                    <div id="info">
                        <center><h1>Edit DLMS Device</h1></center>
                    </div>            
                    <div id="info">
                        <center>
                            <h2><img src="images/warning.png"/> Device / bus mismatch</h2>
                            The device being edited is not on the currently selected bus.<br><br>
                            <a href="rsm_bus_config.lua">Back to bus configuration</a>
                        </center>
                    </div>
]]
            print(header..content..footer)
            os.exit()            
        end
        d.owner = "ddd"
        d.slave = cfg:match([[<slave>%s-(.-)%s-</slave>]]) or "unknown"
        d.muxport = cfg:match([[<muxport>%s-(.-)%s-</muxport>]]) or "unknown"
        d.muxslave = cfg:match([[<muxslave>%s-(.-)%s-</muxslave>]]) or "unknown"
        -- new --
        d.muxbaud = cfg:match([[<muxbaud>%s-(.-)%s-</muxbaud>]]) or "unknown"
        d.muxparity = cfg:match([[<muxparity>%s-(.-)%s-</muxparity>]]) or "unknown"
        d.muxdata = cfg:match([[<muxdata>%s-(.-)%s-</muxdata>]]) or "unknown"
        d.muxstop = cfg:match([[<muxstop>%s-(.-)%s-</muxstop>]]) or "unknown"
        d.muxtype = cfg:match([[<muxtype>%s-(.-)%s-</muxtype>]]) or "unknown"
    end
else
    d = {}
    d.label = ""
    d.serial = "(unassigned)"
    d.template = ""
    d.config = rsm_conf.serialconfig_path
    d.port = bus
    d.owner = "ddd"
    d.slave = ""
    d.muxport = ""
    d.muxslave = ""
    -- new --
    d.muxbaud = ""
    d.muxparity = ""
    d.muxdata = ""
    d.muxstop = ""
    d.muxtype = ""
end

templatesOptions = [[
                                        <option disabled ]] if (mode == "new") then templatesOptions = templatesOptions..[[selected]] end templatesOptions = templatesOptions..[[>Select a template</option>
]]

foundTemplate = 0
if (#(templatesFiles) > 0) then
    for i,f in pairs(templatesFiles) do
        templatesOptions = templatesOptions..[[
                                        <option value="]]..f..[["]] if f == d.template then templatesOptions = templatesOptions .. [[ selected ]] foundTemplate = 1 end templatesOptions = templatesOptions..[[>]]..f..[[</option>
]]            
    end
else
        templatesOptions = [[
                                        <option disabled selected>No templates found</option>
]]
    foundTemplate = 1 -- Yeah this looks like it doesn't make sense, but it does
end
if (foundTemplate == 0) and (mode ~= "new") then
    templatesOptions = templatesOptions .. [[
                                        <option value="]]..d.template..[[" selected title="Template not found!">Template not found (]]..d.template..[[)</template>
]]        
end

content = ""

if (mode == "new") then
    content = content .. [[
                    <div id="info">
                        <div style="background:url(images/busconfig.png); background-size:32px; background-repeat:no-repeat; background-position: 20px center;">
                            <center><h1>Add New DLMS Device</h1></center>
                        </div>
                    </div>
]]
else
    content = content .. [[
                    <div id="info">
                        <div style="background:url(images/busconfig.png); background-size:32px; background-repeat:no-repeat; background-position: 20px center;">
                            <center><h1>Edit DLMS Device</h1></center>
                        </div>
                    </div>
                    <h3>Editing device "]]..d.label..[[" with filename "]]..filename..[[" :</h3>
]]    
end

if (mismatch == 1) then
    -- Bail on error here
    content = [[
                    <div id="info">
                        <center>
                            <h2><img src="images/warning.png"/> Invalid bus</h2>
                            Either an invalid bus was specified, or the bus cannot be matched<br>
                            to a valid DLMS entry in the serial config file "]]..rsm_conf.serialconfig_path..[[".<br><br>
                            <a href="rsm_bus_config.lua">Back to bus configuration</a>
                        </center>
                    </div>
]]
    html = header..content..footer
    print(html)
    os.exit()
end

if (userLevel == 1) then
    content = content .. [[
                    <center><b>Note:</b> Editing this section requires administrator privileges.</center><br>
]]
end

content = content .. [[
                    <script>
                        var doValidate = 0;
                        function validateForm(form)
                        {
                            
                            if (form.getAttribute('submitted')) return false;
                            
                            if (!doValidate)
                            {
                                form.setAttribute('submitted','true');
                                return true;
                            }
                            doValidate = 0;
                            var errors = 0;

                            var label_element = document.getElementById("label");
                            var warning;                           
                            if (label_element.value == "")
                            {
                                errors++;
                            }
                            
                            var template = document.getElementById("template");
                            var warning = document.getElementById("templatewarning");                            
                            if (template.value == "Select a template")
                            {
                                if (!warning)
                                {
                                    warning = document.createElement("span");
                                    warning.id = "templatewarning";
                                    warning.innerHTML = " <img src='images/warning.png' alt='Choose a valid templatek' title='Choose a valid template'/>";
                                    template.parentNode.appendChild(warning);
                                }
                                errors++;
                            }
                            else
                            {
                                if (warning)
                                {
                                    warning.parentNode.removeChild(warning);
                                }
                            }
                            
                            if (errors)
                            {
                                alert("Not all fields have been filled in.\nPlease enter/select valid values for the indicated fields.");
                                return false;
                            }
                            else
                            {
                                form.setAttribute('submitted','true');
                                return true;
                            }
                        }
                    
                    </script>
                    
                    <form action="rsm_dlms_edit.lua" method="post" onsubmit="return validateForm(this);">
                        <div class="formLayoutfull">
                            <table class="onetwo">
                                <tr>
                                    <td style="padding: 5px;" width="50%">
                                        <b>Device Label:</b>
                                    </td>
                                    <td style="padding: 5px;" width="50%">
                                        <input type="text" name="label" value="]]..d.label..[["]]..inputControl..[[ id="label"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Device Serial:</b>
                                    </td>
                                    <td style="padding: 5px;">]]..d.serial..[[</td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>DLMS:</b>
                                    </td>
                                    <td style="padding: 5px;">]]..bus..[[</td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Template File:</b>
                                    </td>
                                    <td style="padding: 5px;">
                                        <select name="template"]]..buttonControl..[[ id="template">
]]
content = content .. templatesOptions
content = content .. [[
                                        </select>
                                    </td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Serial Config:</b>
                                    </td>
                                    <td style="padding: 5px;">]]..d.config..[[</td>
                                </tr>
                            </table>
                            <br>
                            <hr>
                            <br>
]]
if (saved == 1) then
    if (createdNew == 1) then
        content = content .. [[
                            <b><img src="images/ok.png"/> Saved new device with serial ]]..d.serial..[[</b><br><br>
]]
    else
        content = content .. [[
                            <b><img src="images/ok.png"/> Changes saved.</b><br><br>
]]            
    end
end
content = content .. [[
                            <input type="hidden" name="config" value="]]..d.config..[["/>
                            <input type="hidden" name="bus" value="]]..bus..[["/>
                            <input type="hidden" name="file" value="]]..filename..[["/>
                            <input type="button" name="backButton" value="Back to DLMS" onclick="window.location.assign('rsm_dlms_config.lua?bus=]]..bus..[[');"/>
                            <input type="submit" name="saveButton" value="Save and Apply"]]..buttonControl..[[ onclick="doValidate = 1;"/>
]]
if (mode == "edit") then
    content = content .. [[
                            <input type="submit" name="deleteButton" value="Delete Device"]]..buttonControl..[[ onclick="return confirm('Are you sure you want to delete this device?');"/>
]]
end
content = content .. [[
                        </form>
                    </div>
                    
]]    

if (mode == "edit") then
    cfg = cfg:gsub("<","&lt;")
    cfg = cfg:gsub(">","&gt;")
    content = content .. [[    
                    <script>
                        function toggleVis(target)
                        {
                            if (target.style.display == "none")
                            {
                                target.style.display = "inline-block";
                            }
                            else
                            {
                                target.style.display = "none";
                            }
                            return false;
                        }
                    </script>
                    <br><img src="images/magnify.png"/> <a href="javascript:void(0)" onclick="toggleVis(document.getElementById('filecfg'));">View ]]..dlmsPath..[[/]]..filename..[[</a></a><br>
        
                    <div id="filecfg" style="display: none;">
                        <pre class="formLayoutfull">
]]..cfg..[[
                        </pre>
                    </div>    
]]
end


print(header..content..footer)
